## litehtml 0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(litehtml CXX)

add_subdirectory(src/gumbo)

set(SOURCE_LITEHTML
    src/background.cpp
    src/box.cpp
    src/context.cpp
    src/css_length.cpp
    src/css_selector.cpp
    src/document.cpp
    src/el_anchor.cpp
    src/el_base.cpp
    src/el_before_after.cpp
    src/el_body.cpp
    src/el_break.cpp
    src/el_cdata.cpp
    src/el_comment.cpp
    src/el_div.cpp
    src/element.cpp
    src/el_font.cpp
    src/el_image.cpp
    src/el_link.cpp
    src/el_para.cpp
    src/el_script.cpp
    src/el_space.cpp
    src/el_style.cpp
    src/el_table.cpp
    src/el_td.cpp
    src/el_text.cpp
    src/el_title.cpp
    src/el_tr.cpp
    src/html.cpp
    src/html_tag.cpp
    src/iterators.cpp
    src/media_query.cpp
    src/style.cpp
    src/stylesheet.cpp
    src/table.cpp
    src/utf8_strings.cpp
    src/web_color.cpp
)

add_library(${PROJECT_NAME} ${SOURCE_LITEHTML})

set_target_properties(${PROJECT_NAME} PROPERTIES
    CXX_STANDARD 11
    C_STANDARD 99
)

# Export litehtml includes.
target_include_directories(${PROJECT_NAME} PUBLIC src)
target_include_directories(${PROJECT_NAME} PUBLIC include)

# Gumbo
target_link_libraries(${PROJECT_NAME} PUBLIC gumbo)

=== src/gumbo/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(gumbo C)

set(SOURCE_GUMBO
    attribute.c
    char_ref.c
    error.c
    parser.c
    string_buffer.c
    string_piece.c
    tag.c
    tokenizer.c
    utf8.c
    util.c
    vector.c
)

add_library(${PROJECT_NAME} ${SOURCE_GUMBO})

set_target_properties(${PROJECT_NAME} PROPERTIES
    C_STANDARD 99
)

if(MSVC)
    target_include_directories(${PROJECT_NAME} PRIVATE visualc/include)
endif()

# Export gumbo includes.
target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR})

=== debian/changelog ===
litehtml (0.5-3) unstable; urgency=medium

  * Update symbols file

 -- Yangfl <mmyangfl@gmail.com>  Sat, 18 Jul 2020 15:42:58 +0800

litehtml (0.5-2) unstable; urgency=medium

  * Bump debhelper compat to 13

 -- Yangfl <mmyangfl@gmail.com>  Sat, 18 Jul 2020 02:34:10 +0800

litehtml (0.5-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload to allow testing migration. 

 -- Boyuan Yang <byang@debian.org>  Thu, 16 Apr 2020 16:46:57 -0400

litehtml (0.5-1) unstable; urgency=medium

  * Initial release (Closes: #947498)

 -- Yangfl <mmyangfl@gmail.com>  Wed, 11 Mar 2020 15:26:24 +0800

=== debian/control ===
Source: litehtml
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgumbo-dev,
 pkg-kde-tools,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/litehtml/litehtml
Vcs-Git: https://salsa.debian.org/yangfl-guest/litehtml.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/litehtml

Package: liblitehtml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblitehtml0 (= ${binary:Version}), ${misc:Depends}
Description: lightweight HTML rendering engine with CSS2/CSS3 support (development files)
 litehtml is the lightweight HTML rendering engine with CSS2/CSS3 support. Note
 that litehtml itself does not draw any text, pictures or other graphics and
 that litehtml does not depend on any image/draw/font library. You are free to
 use any library to draw images, fonts and any other graphics. litehtml just
 parses HTML/CSS and places the HTML elements into the correct positions
 (renders HTML).
 .
 This package contains the header files.

Package: liblitehtml0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight HTML rendering engine with CSS2/CSS3 support
 litehtml is the lightweight HTML rendering engine with CSS2/CSS3 support. Note
 that litehtml itself does not draw any text, pictures or other graphics and
 that litehtml does not depend on any image/draw/font library. You are free to
 use any library to draw images, fonts and any other graphics. litehtml just
 parses HTML/CSS and places the HTML elements into the correct positions
 (renders HTML).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/pkg-info.mk


%:
	dh $@ --with pkgkde-symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DLITEHTML_VERSION=$(DEB_VERSION_UPSTREAM)

## litehtml 0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(litehtml LANGUAGES C CXX)
include(CTest)
enable_testing()

# Soname
# MAJOR is incremented when symbols are removed or changed in an incompatible way
# MINOR is incremented when new symbols are added
set(PROJECT_MAJOR 0)
set(PROJECT_MINOR 0)

option(EXTERNAL_GUMBO "Link against external gumbo instead of shipping a bundled copy" OFF)

if(NOT EXTERNAL_GUMBO)
    add_subdirectory(src/gumbo)
endif()

set(SOURCE_LITEHTML
    src/background.cpp
    src/box.cpp
    src/codepoint.cpp
    src/context.cpp
    src/css_length.cpp
    src/css_selector.cpp
    src/document.cpp
    src/el_anchor.cpp
    src/el_base.cpp
    src/el_before_after.cpp
    src/el_body.cpp
    src/el_break.cpp
    src/el_cdata.cpp
    src/el_comment.cpp
    src/el_div.cpp
    src/element.cpp
    src/el_font.cpp
    src/el_image.cpp
    src/el_link.cpp
    src/el_li.cpp
    src/el_para.cpp
    src/el_script.cpp
    src/el_space.cpp
    src/el_style.cpp
    src/el_table.cpp
    src/el_td.cpp
    src/el_text.cpp
    src/el_title.cpp
    src/el_tr.cpp
    src/html.cpp
    src/html_tag.cpp
    src/iterators.cpp
    src/media_query.cpp
    src/style.cpp
    src/stylesheet.cpp
    src/table.cpp
    src/tstring_view.cpp
    src/url.cpp
    src/url_path.cpp
    src/utf8_strings.cpp
    src/web_color.cpp
    src/num_cvt.cpp
    src/strtod.cpp
)

set(HEADER_LITEHTML
    include/litehtml.h
    include/litehtml/attributes.h
    include/litehtml/background.h
    include/litehtml/borders.h
    include/litehtml/box.h
    include/litehtml/codepoint.h
    include/litehtml/context.h
    include/litehtml/css_length.h
    include/litehtml/css_margins.h
    include/litehtml/css_offsets.h
    include/litehtml/css_position.h
    include/litehtml/css_selector.h
    include/litehtml/document.h
    include/litehtml/el_anchor.h
    include/litehtml/el_base.h
    include/litehtml/el_before_after.h
    include/litehtml/el_body.h
    include/litehtml/el_break.h
    include/litehtml/el_cdata.h
    include/litehtml/el_comment.h
    include/litehtml/el_div.h
    include/litehtml/el_font.h
    include/litehtml/el_image.h
    include/litehtml/el_link.h
    include/litehtml/el_para.h
    include/litehtml/el_script.h
    include/litehtml/el_space.h
    include/litehtml/el_style.h
    include/litehtml/el_table.h
    include/litehtml/el_td.h
    include/litehtml/el_text.h
    include/litehtml/el_title.h
    include/litehtml/el_tr.h
    include/litehtml/element.h
    include/litehtml/html.h
    include/litehtml/html_tag.h
    include/litehtml/iterators.h
    include/litehtml/media_query.h
    include/litehtml/os_types.h
    include/litehtml/style.h
    include/litehtml/stylesheet.h
    include/litehtml/table.h
    include/litehtml/tstring_view.h
    include/litehtml/types.h
    include/litehtml/url.h
    include/litehtml/url_path.h
    include/litehtml/utf8_strings.h
    include/litehtml/web_color.h
    include/litehtml/num_cvt.h
)

set(TEST_LITEHTML
    containers/test/container_test.cpp
    test/codepoint_test.cpp
    test/contextTest.cpp
    test/cssTest.cpp
    test/documentTest.cpp
    test/layoutGlobalTest.cpp
    test/mediaQueryTest.cpp
    test/tstring_view_test.cpp
    test/url_test.cpp
    test/url_path_test.cpp
    test/webColorTest.cpp
)

set(PROJECT_LIB_VERSION ${PROJECT_MAJOR}.${PROJECT_MINOR}.0)
set(PROJECT_SO_VERSION ${PROJECT_MAJOR})

add_library(${PROJECT_NAME} ${SOURCE_LITEHTML})
set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_LIB_VERSION} SOVERSION ${PROJECT_SO_VERSION})

set_target_properties(${PROJECT_NAME} PROPERTIES
    CXX_STANDARD 11
    C_STANDARD 99
    PUBLIC_HEADER "${HEADER_LITEHTML}"
)

# Export litehtml includes.
target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/${PROJECT_NAME}>)
target_include_directories(${PROJECT_NAME} PRIVATE include/${PROJECT_NAME})

option(LITEHTML_UTF8 "Build litehtml with UTF-8 text conversion functions." OFF)
if (LITEHTML_UTF8)
  target_compile_definitions(${PROJECT_NAME} PUBLIC LITEHTML_UTF8)
endif()

# Gumbo
target_link_libraries(${PROJECT_NAME} PUBLIC gumbo)

# install and export
install(TARGETS ${PROJECT_NAME}
    EXPORT litehtmlTargets
    RUNTIME DESTINATION bin COMPONENT libraries
    ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT libraries
    LIBRARY DESTINATION lib${LIB_SUFFIX} COMPONENT libraries
    PUBLIC_HEADER DESTINATION include/litehtml
)
install(FILES cmake/litehtmlConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/litehtml)
install(EXPORT litehtmlTargets FILE litehtmlTargets.cmake DESTINATION lib${LIB_SUFFIX}/cmake/litehtml)

# Generate master.css.inc
function(make_inc src dst)
    file(READ  ${src} data)
    file(WRITE ${dst} "R\"##(\n${data})##\"")
endfunction(make_inc)
make_inc(include/master.css src/master.css.inc)
set_source_files_properties(src/master.css.inc PROPERTIES GENERATED TRUE)

# Tests

if (BUILD_TESTING)
    include(FetchContent)
    FetchContent_Declare(
      googletest
      URL https://github.com/google/googletest/archive/609281088cfefc76f9d0ce82e1ff6c30cc3591e5.zip
    )
    # For Windows: Prevent overriding the parent project's compiler/linker settings
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    FetchContent_GetProperties(googletest)
    if(NOT googletest_POPULATED)
      FetchContent_Populate(googletest)
      add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR})
    endif()

    enable_testing()

    set(TEST_NAME ${PROJECT_NAME}_tests)

    add_executable(
        ${TEST_NAME}
        ${TEST_LITEHTML}
        ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc
    )

    set_target_properties(${TEST_NAME} PROPERTIES
        CXX_STANDARD 11
        C_STANDARD 99
        PUBLIC_HEADER "${HEADER_LITEHTML}"
    )

    target_include_directories(
        ${TEST_NAME}
        PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/containers
    )

    target_link_libraries(
        ${TEST_NAME}
        ${PROJECT_NAME}
        gtest_main
    )

    include(GoogleTest)
    gtest_discover_tests(${TEST_NAME})
endif()

#     set(TEST_NAME ${PROJECT_NAME}_tests)
#     add_executable(${TEST_NAME} ${TEST_LITEHTML} ${CMAKE_CURRENT_SOURCE_DIR}/src/master.css.inc)
#     set_target_properties(${TEST_NAME} PROPERTIES
#         CXX_STANDARD 11
#         C_STANDARD 99
#         PUBLIC_HEADER "${HEADER_LITEHTML}"
#     )
#     target_include_directories(${TEST_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/containers)
#     target_link_libraries(${TEST_NAME} PRIVATE ${PROJECT_NAME})
#     # tests
#     add_test(NAME contextTest COMMAND ${TEST_NAME} 1)
#     add_test(NAME cssTest COMMAND ${TEST_NAME} 2)
#     add_test(NAME documentTest COMMAND ${TEST_NAME} 3)
#     add_test(NAME layoutGlobalTest COMMAND ${TEST_NAME} 4)
#     add_test(NAME mediaQueryTest COMMAND ${TEST_NAME} 5)
#     add_test(NAME webColorTest COMMAND ${TEST_NAME} 6)
# endif()

=== debian/changelog ===
litehtml (0.6-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062755

 -- Graham Inggs <ginggs@debian.org>  Wed, 28 Feb 2024 21:16:32 +0000

litehtml (0.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols file. (Closes: #1037758)

 -- Pino Toscano <pino@debian.org>  Fri, 18 Aug 2023 07:48:05 +0200

litehtml (0.6-1) unstable; urgency=medium

  * New upstream release
  * Update symbols from build logs
  * Bump Standards-Version to 4.6.1
  [ Rob Savoury ]
  * debian/patches/: Rebase CMakeLists.patch (partially upstreamed, but with
    no multiarch for install so retain that, also fix new litehtmlConfig.cmake
    to not search for gumbo with find_dependency due no gumbo CMake config)
    (Closes: #1018006)
  * d/control: Add required libgumbo-dev dependency to liblitehtml-dev package
  * d/rules: Add {EXTERNAL_GUMBO,LITEHTML_UTF8}=ON, BUILD_TESTING=OFF configs
  * Update symbols from build logs

 -- Yangfl <mmyangfl@gmail.com>  Tue, 11 Oct 2022 06:06:37 +0800

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: litehtml
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  libgumbo-dev,
  pkg-kde-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/litehtml/litehtml
 Vcs-Git: https://salsa.debian.org/yangfl-guest/litehtml.git
@@ -17,7 +17,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: liblitehtml0 (= ${binary:Version}), ${misc:Depends}
+Depends: liblitehtml0t64 (= ${binary:Version}), libgumbo-dev, ${misc:Depends}
 Description: lightweight HTML rendering engine with CSS2/CSS3 support (development files)
  litehtml is the lightweight HTML rendering engine with CSS2/CSS3 support. Note
  that litehtml itself does not draw any text, pictures or other graphics and
@@ -28,7 +28,10 @@
  .
  This package contains the header files.
 
-Package: liblitehtml0
+Package: liblitehtml0t64
+Provides: ${t64:Provides}
+Replaces: liblitehtml0
+Breaks: liblitehtml0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?r?(\d[\d.]*)\.tar\.gz%litehtml-$1.tar.gz%" \
   https://github.com/litehtml/litehtml/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## litehtml 0.9

=== debian/changelog ===
litehtml (0.9-1) unstable; urgency=medium

  * New upstream release
  * Remove liblitehtml0 due to lack of stable ABI
    * Fix FTBFS with GCC-15 (Closes: #1097306)
  * Enable LTO (Closes: #1015535)
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Sat, 13 Sep 2025 14:24:27 +0800

=== debian/control ===
Source: litehtml
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 cmake,
 libgumbo-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/litehtml/litehtml
Vcs-Git: https://salsa.debian.org/yangfl-guest/litehtml.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/litehtml

Package: liblitehtml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgumbo-dev, ${misc:Depends}
Description: lightweight HTML rendering engine with CSS2/CSS3 support (development files)
 litehtml is the lightweight HTML rendering engine with CSS2/CSS3 support. Note
 that litehtml itself does not draw any text, pictures or other graphics and
 that litehtml does not depend on any image/draw/font library. You are free to
 use any library to draw images, fonts and any other graphics. litehtml just
 parses HTML/CSS and places the HTML elements into the correct positions
 (renders HTML).
 .
 This package contains the header files and static lib.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@

override_dh_auto_configure:
	# disable testing due to outdated cpp std used by upstream for the moment,
	# may be re-enabled in the future
	dh_auto_configure -- \
		-DEXTERNAL_GUMBO=ON \
		-DLITEHTML_BUILD_TESTING=OFF

=== debian/watch ===
Version: 5
Template: Github
Owner: litehtml
Project: litehtml
